unit FListe;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QExtCtrls, UStandard, QButtons;



type
  TForm1 = class(TForm)
    Panel1: TPanel;
    liste: TListBox;
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Edit1: TEdit;
    BitBtn6: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
  private
  public
    list1: TStringlist;
    list2: TStringlist;
    list3: TStringlist;
    olist: TStringlist;
    clist: TStringlist;
    mlist: TStringlist;
    modellist: String;
    collidablelist: String;
    objectlist: String;
    procedure Auswertung;
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.Auswertung; {===============================}
var line, sss, cup, model, coll, obj, chapt, a, b, ss: String;
    anz,i,po,po1, idx, nr: integer;

function ModelName (s: string): string;
begin
  po := pos (':models:', s);
  if po > 0 then begin
    s := copy (s, po+8, 255);
    po1 := pos ('}',s);
    if po1 > 0 then s := copy (s,1,po1-1);
    Result := s;
  end else Result := '';
end;

function ObjectName (s: string): string;
begin
  po := pos (':object:', s);
  if po > 0 then begin
    s := copy (s, po+8, 255);
    po1 := pos ('\',s);
    if po1 > 0 then s := copy (s,1,po1-2);
    Result := s;
  end else Result := '';
end;

function CollName (s: string): string;
begin
  po := pos (':collidables:', s);
  if po > 0 then begin
    s := copy (s, po+13, 255);
    po1 := pos ('}',s);
    if po1 > 0 then s := copy (s,1,po1-1);
    Result := s;
  end else Result := '';
end;

begin
  list1.LoadFromFile (ProgDir + 'res/textures2.tcl');
  for i := 0 to list1.Count-1 do list1[i] := BareStr (list1[i]);

  for i := list1.Count-1 downto 1 do begin
    a := list1[i-1];
    b := list1[i];
    if (a <> '') and (b <> '') then begin
      if a[length(a)] = '\' then begin
//        delete (a, length(a), 1);
        list1[i-1] := a + b;
        list1[i] := '';
      end;
    end;
  end;

  for i := list1.count-1 downto 0 do if list1[i] = '' then list1.delete(i);
  for i := list1.count-1 downto 0 do if list1[i][1] = '-' then list1.delete(i);

  for i := 0 to list1.count-1 do begin
    ss := list1[i];
    if pos ('[cup]',ss) >0 then begin
      cup := ParsStr (ss, 'cup');
    end else begin
      list1[i] := '[cp]'+ copy (cup,1,1)
//         + '[mod]' + ModelName(ss)
         + '[obj]' + ObjectName(ss)
//         + '[coll]' + CollName (ss)
         + '[line] ' + list1[i];
    end;
  end;

  for i := list1.count-1 downto 0 do begin
    if pos('[cp]',list1[i])=0 then list1.delete(i);
  end;
//  list1.add(inttostr(list1.count));


  objectlist := '';
  list3.clear;
  for i:= 0 to list1.count-1 do begin
    ss := list1[i];
    obj := '-' +  ParsStr(ss,'obj') + '-';
    if pos (obj, objectlist) = 0 then begin
      objectlist := objectlist + obj;
      list3.add (ss);
    end;
  end;
  edit1.text := objectlist;
//  list3.add(inttostr(list3.count));

  list2.clear;
  for i:= 0 to list3.count-1 do begin
    ss := list3[i];
    if ss[1]='#' then begin
      list2.add (ss);
    end else begin
      list2.add ('[line]' + ParsStr (ss, 'line'));
    end;
  end;
//  list2.add (inttostr(list2.count));

  list3.clear;
  for i:= 0 to list2.count-1 do begin
    ss := list2[i];
    if ss[1]='#' then begin
      list3.add (ss);
    end else begin
      chapt := ParsStr (ss, 'ch');
      line := '[1]'+ ParsStr (ss, 'line');
      anz := 1;
      repeat
        po := pos ('\',line);
        if po >0 then begin
          delete (line, po, 1);
          inc(anz);
          insert ('[' + inttostr(anz) + ']',line,po);
        end;
      until po = 0;
      for nr := 1 to anz do begin
        sss := ParsStr (line, IntTostr(nr));
        if nr < anz then sss := sss + ' \';
        if nr>1 then sss := chr(9) + sss;
        list3.add (sss);
      end;
      list3.add ('');
    end;
  end;
//  list2.add (inttostr(list2.count));

(*
  // nach cups umordnen in list2
  list2.clear;
  for i := 0 to list1.count-1 do begin
    ss := list1[i];
    if ParsStr (ss, 'cp') = 'a' then list2.add(ss);
  end;
  for i := 0 to list1.count-1 do begin
    ss := list1[i];
    if ParsStr (ss, 'cp') = 'f' then list2.add(ss);
  end;
  for i := 0 to list1.count-1 do begin
    ss := list1[i];
    if ParsStr (ss, 'cp') = 's' then list2.add(ss);
  end;
  for i := 0 to list1.count-1 do begin
    ss := list1[i];
    if ParsStr (ss, 'cp') = 'g' then list2.add(ss);
  end;
  for i := 0 to list1.count-1 do begin
    ss := list1[i];
    if ParsStr (ss, 'cp') = 'm' then list2.add(ss);
  end;
  list2.add(inttostr(list2.count));

  // nach chapt umordnen in speziallisten mlist,  clist und olist
  mlist.clear;
  clist.clear;
  olist.clear;
  for i := 0 to list2.count-1 do begin
    ss := list2[i];
    if ParsStr (ss, 'ch') = 'm' then mlist.add(ss);
  end;
  for i := 0 to list2.count-1 do begin
    ss := list2[i];
    if ParsStr (ss, 'ch') = 'c' then clist.add(ss);
  end;
  for i := 0 to list2.count-1 do begin
    ss := list2[i];
    if ParsStr (ss, 'ch') = 'o' then olist.add(ss);
  end;
//  mlist.add (inttostr (mlist.count));
//  clist.add (inttostr (clist.count));
//  olist.add (inttostr (olist.count));



  list3.clear;
  list3.add ('#');
  list3.add ('# models');
  list3.add ('#');
  modellist := '';
  for i:= 0 to mlist.count-1 do begin
    ss := mlist[i];
    model := '-' + ParsStr (ss, 'mod') + '-';
    if pos (model, modellist) = 0 then begin
      modellist := modellist + model;
      list3.add (ss);
    end;
  end;

  collidablelist := '';
  list3.add ('#');
  list3.add ('# collidables');
  list3.add ('#');
  for i:= 0 to clist.count-1 do begin
    ss := clist[i];
    coll := '-' + ParsStr (ss, 'coll') + '-';
    if pos (coll, collidablelist) = 0 then begin
      collidablelist := collidablelist + coll;
      list3.add (ss);
    end;
  end;

  objectlist := '';
  list3.add ('#');
  list3.add ('# objects');
  list3.add ('#');
  for i:= 0 to olist.count-1 do begin
    ss := olist[i];
    obj := '-' + ParsStr (ss, 'obj') + '-';
    if pos (obj, objectlist) = 0 then begin
      objectlist := objectlist + obj;
      list3.add (ss);
    end;
  end;
//  list3.add (inttostr(list3.count));

  list2.clear;
  for i:= 0 to list3.count-1 do begin
    ss := list3[i];
    if ss[1]='#' then begin
      list2.add (ss);
    end else begin
      chapt := ParsStr (ss, 'ch');
      list2.add ('[ch]' + chapt + '[line]' + ParsStr (ss, 'line'));
    end;
  end;
  list2.add (inttostr(list2.count));

  list3.clear;
  for i:= 0 to list2.count-1 do begin
    ss := list2[i];
    if ss[1]='#' then begin
      list3.add (ss);
    end else begin
      chapt := ParsStr (ss, 'ch');
      line := '[1]'+ ParsStr (ss, 'line');
      anz := 1;
      repeat
        po := pos ('\',line);
        if po >0 then begin
          delete (line, po, 1);
          inc(anz);
          insert ('[' + inttostr(anz) + ']',line,po);
        end;
      until po = 0;
      for nr := 1 to anz do begin
        sss := ParsStr (line, IntTostr(nr));
        if nr < anz then sss := sss + ' \';
        if nr>1 then sss := chr(9) + sss;
        list3.add (sss);
      end;
      list3.add ('');
    end;
  end;
  list2.add (inttostr(list2.count));





(* // Wiederholungstest
  list2.clear;
  for i:= 0 to list1.count-1 do begin
    ss := list1[i];
    model := ParsStr(ss,'mod');
    coll := ParsStr (ss,'coll');
    obj:= ParsStr (ss,'obj');
    if (obj='') and (coll = 'tunnel_opening2') then list2.add(ss);
  end;                 *)

  // Auswahl der Rubrik und bertragung nach list 2
(*  list2.clear;
  for i:= 0 to list1.count-1 do begin
    ss := list1[i];
    chapt := ParsStr (ss,'ch');
    if chapt = 'm' then list2.add (ss);
  end;*)
(*  for i:= 0 to list1.count-1 do begin
    ss := list1[i];
    chapt := ParsStr (ss,'ch');
    if chapt = 'c' then list2.add (ss);
  end; *)
(*  for i:= 0 to list1.count-1 do begin
    ss := list1[i];
    chapt := ParsStr (ss,'ch');
    if chapt = 'o' then list2.add (ss);
  end;*)

  // Zusammenstellung der Objekte in OList
(*  modellist := '';
  olist.clear;
  for i:= 0 to list2.count-1 do begin
    ss := list2[i];
    obj := ParsStr (ss, 'obj');
    idx := ParsInt (modellist, obj, -1);
    cup := ParsStr (ss, 'cp');
    if idx < 0 then begin
      olist.add ('[anz]1[obj]' + obj + '     ' + cup);
      SetParsint (modellist, obj, olist.count-1);
    end else begin
      sss := olist[idx];
      anz := parsint (sss,'anz',0);
      SetParsInt (sss,'anz',anz+1);
      olist[idx] := sss + ' ' + cup;
    end;
  end;
  olist.add(inttostr(olist.count));

  // Zusammenstellung der Collidables in CList
  modellist := '';
  clist.clear;
  for i:= 0 to list2.count-1 do begin
    ss := list2[i];
    model := ParsStr (ss, 'coll');
    idx := ParsInt (modellist, model, -1);
    cup := ParsStr (ss, 'cp');
    if idx < 0 then begin
      clist.add ('[anz]1[mod]' + model + '     ' + cup);
      SetParsint (modellist, model, clist.count-1);
    end else begin
      sss := clist[idx];
      anz := parsint (sss,'anz',0);
      SetParsInt (sss,'anz',anz+1);
      clist[idx] := sss + ' ' + cup;
    end;
  end;
  clist.add(inttostr(olist.count));

  // Zusammenstellung der Models in MList
  modellist := '';
  mlist.clear;
  for i:= 0 to list2.count-1 do begin
    ss := list2[i];
    model := ParsStr (ss, 'mod');
    idx := ParsInt (modellist, model, -1);
    cup := ParsStr (ss, 'cp');
    if idx < 0 then begin
      mlist.add ('[anz]1[mod]' + model + '     ' + cup);
      SetParsint (modellist, model, mlist.count-1);
    end else begin
      sss := mlist[idx];
      anz := parsint (sss,'anz',0);
      SetParsInt (sss,'anz',anz+1);
      mlist[idx] := sss + ' ' + cup;
    end;
  end;
  mlist.add(inttostr(olist.count));

  for i:= 0 to mlist.count-1 do begin
    ss := mlist[i];
    if ParsInt (ss, 'anz', 0) > 1 then list3.add(ss);
  end;*)


  Liste.items := list1;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  list1 := TStringlist.Create;
  list1.sorted := false;
  list2 := TStringlist.Create;
  list2.sorted := false;
  list3 := TStringlist.Create;
  list3.sorted := false;
  olist := TStringlist.Create;
  olist.sorted := false;
  clist := TStringlist.Create;
  clist.sorted := false;
  mlist := TStringlist.Create;
  mlist.sorted := false;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Auswertung;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  begin end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  list1.Free;
  list2.Free;
  list3.Free;
  olist.Free;
  clist.Free;
  mlist.Free;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  liste.items := list1;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  liste.items := list2;
end;

procedure TForm1.BitBtn6Click(Sender: TObject);
begin
  liste.items := list3;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  list3.saveToFile (ProgDir + 'res/test');
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
  liste.items := OList;
end;

procedure TForm1.BitBtn7Click(Sender: TObject);
begin
  liste.items := clist;
end;

procedure TForm1.BitBtn8Click(Sender: TObject);
begin
  liste.items := mlist;
end;

end.
