unit FRenameEvent;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, UStandard, UManageBase, QButtons;

type
  TRenameEventForm = class(TForm)
    Edit0: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    CancelButton: TBitBtn;
    OKButton: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure FormShow(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
  private
    list: array[0..4] of String;
  public
  end;

var
  RenameEventForm: TRenameEventForm;

implementation

{$R *.xfm}

procedure TRenameEventForm.FormShow(Sender: TObject);
var ev: integer;
begin
  for ev := 0 to 4 do list[ev] := EventList[ev][0];
  Edit0.text := ParsStr (list[0], 'trivname');
  Edit1.text := ParsStr (list[1], 'trivname');
  Edit2.text := ParsStr (list[2], 'trivname');
  Edit3.text := ParsStr (list[3], 'trivname');
  Edit4.text := ParsStr (list[4], 'trivname');
end;

procedure TRenameEventForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TRenameEventForm.OKButtonClick(Sender: TObject);
var ev: Integer;
begin
  SetParsStr (list[0], 'trivname', Edit0.text);
  SetParsStr (list[1], 'trivname', Edit1.text);
  SetParsStr (list[2], 'trivname', Edit2.text);
  SetParsStr (list[3], 'trivname', Edit3.text);
  SetParsStr (list[4], 'trivname', Edit4.text);
  for ev := 0 to 4 do EventList[ev][0] := list[ev];
  ModalResult := mrOK;
end;

end.
