unit FWarn;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QButtons;

type
  TWarnForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button: TBitBtn;
    CancelButton: TBitBtn;
    procedure ButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  WarnForm: TWarnForm;

implementation

{$R *.xfm}

procedure TWarnForm.ButtonClick(Sender: TObject);
begin
  ModalResult := mrOK;
end;

procedure TWarnForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TWarnForm.FormShow(Sender: TObject);
begin
  CancelButton.SetFocus;
end;

end.
