unit FConfigWrite;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QButtons, UTCL;

type
  TConfigWriteForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    OKButton: TBitBtn;
    CancelButton: TBitBtn;
    Label5: TLabel;
    procedure OKButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
  public
    flag: integer;
  end;

var
  ConfigWriteForm: TConfigWriteForm;

implementation

{$R *.xfm}

// uses FTuxmanager;

procedure TConfigWriteForm.OKButtonClick(Sender: TObject);
begin
//  ModalResult := mrOK;
  case flag of
    1: GenerateCourseIdxTCL;
    2: GenerateLightTCL;
  end;
  OKButton.visible := false;
  Label1.visible := false;
  Label2.visible := false;
  Label3.caption := 'The configuration files have been successful written';
  CancelButton.Caption := 'Exit';
end;

procedure TConfigWriteForm.CancelButtonClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TConfigWriteForm.FormShow(Sender: TObject);
begin
  CancelButton.Caption := 'Cancel';
  OKButton.visible := true;
  label1.visible := true;
  label2.visible := true;
  Label3.caption := '';
end;

end.
