unit FTuxmanager;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, UStandard, QMenus, UManageBase, QExtCtrls, FCourseDir,
  QButtons, Libc, QComCtrls, UTCL;

const
  PassCol: TColor = $00BBBBBB;
  PassCol2: TColor = $00FFFFFF;

type
  TMain = class(TForm)
    MainMenu1: TMainMenu;
    mmFile: TMenuItem;
    mmEvents: TMenuItem;
    mmSettings: TMenuItem;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    MainRegister: TPageControl;
    start: TTabSheet;
    work: TTabSheet;
    CoverPanel: TPanel;
    StartPanel: TPanel;
    CourseDirButton: TSpeedButton;
    BackupButton: TSpeedButton;
    PrepButton: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Progress: TProgressBar;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    CourseDirPanel: TPanel;
    BackupPanel: TPanel;
    PrepPanel: TPanel;
    Label3: TLabel;
    Startbutton: TBitBtn;
    HelpPanel: TPanel;
    HelpCloseButton: TBitBtn;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Panel6: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel8: TPanel;
    MainList: TListBox;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel19: TPanel;
    Panel3: TPanel;
    RightPanel: TPanel;
    Panel21: TPanel;
    Panel7: TPanel;
    EditRegister: TPageControl;
    select: TTabSheet;
    intern: TTabSheet;
    Panel18: TPanel;
    Panel20: TPanel;
    CourseBox: TListBox;
    liste99: TListBox;
    Button1: TButton;
    Button3: TButton;
    Edit2: TEdit;
    Button5: TButton;
    EventCombo: TComboBox;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    mmInstall: TMenuItem;
    N1: TMenuItem;
    mmQuit: TMenuItem;
    mmScanDir: TMenuItem;
    mmCourseOrder: TMenuItem;
    Panel2: TPanel;
    Dummy: TBitBtn;
    mmNewCourse: TMenuItem;
    mmReset: TMenuItem;
    mmConfiguration: TMenuItem;
    Panel9: TPanel;
    Panel15: TPanel;
    NameEdit: TEdit;
    DescEdit: TMemo;
    CourseEditPanel: TPanel;
    NormalHerr: TSpinEdit;
    HardTime: TSpinEdit;
    EasyTime: TSpinEdit;
    HardHerr: TSpinEdit;
    NormalTime: TSpinEdit;
    EasyHerr: TSpinEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Panel11: TPanel;
    WindCheck: TCheckBox;
    SnowCheck: TCheckBox;
    CondRadio: TRadioGroup;
    Label27: TLabel;
    Panel22: TPanel;
    IconImage: TImage;
    OppCheck: TCheckBox;
    HideButton: TSpeedButton;
    HidePanel: TPanel;
    N2: TMenuItem;
    mmClearEvent: TMenuItem;
    mmClearAllEvents: TMenuItem;
    env: TTabSheet;
    Panel23: TPanel;
    EnvButton: TSpeedButton;
    TopCover: TPanel;
    mmRename: TMenuItem;
    SunnyLightPanel: TPanel;
    SunnyOpenButton: TBitBtn;
    SunsetLightPanel: TPanel;
    SunsetOpenButton: TBitBtn;
    FoggyLightPanel: TPanel;
    FoggyOpenButton: TBitBtn;
    EnvRadio: TRadioGroup;
    ViewRadio: TRadioGroup;
    Panel10: TPanel;
    Label29: TLabel;
    Pos1: TEdit;
    Label63: TLabel;
    Pos2: TEdit;
    Label64: TLabel;
    Pos3: TEdit;
    Panel12: TPanel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    ParticlePanel: TPanel;
    FogPanel: TPanel;
    SpecularPanel: TPanel;
    DiffusePanel: TPanel;
    AmbientPanel: TPanel;
    Panel13: TPanel;
    Panel14: TPanel;
    EnvPreview: TImage;
    CubeCombo: TComboBox;
    ColorDialog: TColorDialog;
    Label13: TLabel;
    Label28: TLabel;
    Label35: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Potrack2: TTrackBar;
    Potrack1: TTrackBar;
    Potrack3: TTrackBar;
    mmLang: TMenuItem;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton5: TSpeedButton;
    DeleteButton: TSpeedButton;
    AddCupButton: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SaveEnvButton: TSpeedButton;
    SpeedButton7: TSpeedButton;
    CupsButton: TSpeedButton;
    mmHelp: TMenuItem;
    mmAbout: TMenuItem;
    Label25: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure AddCupButtonClick(Sender: TObject);
    procedure MainListClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure StartbuttonClick(Sender: TObject);
    procedure BackupButtonClick(Sender: TObject);
    procedure PrepButtonClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure HelpCloseButtonClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure DeleteButtonClick(Sender: TObject);
    procedure MainRegisterChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure EditRegisterChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure EventComboChange(Sender: TObject);
    procedure CourseBoxClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure mmQuitClick(Sender: TObject);
    procedure mmScandirClick(Sender: TObject);
    procedure CourseDirButtonClick(Sender: TObject);
    procedure NameEditChange(Sender: TObject);
    procedure DescEditChange(Sender: TObject);
    procedure EasyHerrChanged(Sender: TObject; NewValue: Integer);
    procedure NormalHerrChanged(Sender: TObject; NewValue: Integer);
    procedure HardHerrChanged(Sender: TObject; NewValue: Integer);
    procedure EasyTimeChanged(Sender: TObject; NewValue: Integer);
    procedure NormalTimeChanged(Sender: TObject; NewValue: Integer);
    procedure HardTimeChanged(Sender: TObject; NewValue: Integer);
    procedure WindCheckClick(Sender: TObject);
    procedure SnowCheckClick(Sender: TObject);
    procedure CondRadioClick(Sender: TObject);
    procedure HideButtonClick(Sender: TObject);
    procedure OppCheckClick(Sender: TObject);
    procedure mmRenameClick(Sender: TObject);
    procedure mmResetClick(Sender: TObject);
    procedure mmClearEventClick(Sender: TObject);
    procedure mmClearAllEventsClick(Sender: TObject);
    procedure mmConfigurationClick(Sender: TObject);
    procedure mmCourseOrderClick(Sender: TObject);
    procedure mmInstallClick(Sender: TObject);
    procedure mmNewCourseClick(Sender: TObject);
    procedure mmEnvironmentClick(Sender: TObject);
    procedure SunnyOpenButtonClick(Sender: TObject);
    procedure SunsetOpenButtonClick(Sender: TObject);
    procedure FoggyOpenButtonClick(Sender: TObject);
    procedure EnvRadioClick(Sender: TObject);
    procedure ViewRadioClick(Sender: TObject);
    procedure AmbientPanelClick(Sender: TObject);
    procedure DiffusePanelClick(Sender: TObject);
    procedure SpecularPanelClick(Sender: TObject);
    procedure FogPanelClick(Sender: TObject);
    procedure ParticlePanelClick(Sender: TObject);
    procedure CubeComboClick(Sender: TObject);
    procedure SaveEnvButtonClick(Sender: TObject);
    procedure Potrack1Change(Sender: TObject);
    procedure Potrack2Change(Sender: TObject);
    procedure Potrack3Change(Sender: TObject);
    procedure mmEnvResetClick(Sender: TObject);
    procedure mmLangClick(Sender: TObject);
    procedure CupsButtonClick(Sender: TObject);
    procedure mmAboutClick(Sender: TObject);
  private
    MainChange: boolean;
    EditChange: boolean;
    EnvMarkStr: String;

    procedure FillEventCombo;
    procedure SetMainPanel (pan: integer);
    procedure SetEditPanel (pan: integer);
    procedure SetMark;
    procedure AddCup;
    procedure AddCourse;
    procedure SetCourseDir;
    procedure BackupCourses;
    procedure Preparations;
    procedure ShowMainList;
    procedure CheckStructure;
    procedure ShowEnv;
  public
  end;

var
  Main: TMain;

implementation

uses FRenameEvent, FOrder, FInstall, FNewCourse, FWarn, FCube, FLang,
  FConfigWrite, FAbout;

{$R *.xfm}

procedure TMain.SetMainPanel; {--------------------------------}
begin
  case pan of
    panCover: MainRegister.ActivePage := start;
    panWork: MainRegister.ActivePage := work;
    panEnv: MainRegister.ActivePage := env;
  end;
end;

procedure TMain.SetEditPanel; {--------------------------------}
begin
  case pan of
    panSelect: EditRegister.ActivePage := select;
    panIntern: EditRegister.ActivePage := intern;
  end;
end;

procedure TMain.SetMark; {-------------------------------------}
var cond, ss: String;
begin
  if MainList.ItemIndex < 0 then begin
    CourseBox.color := PassCol2;
    CourseBox.enabled := false;
    FMarkStruct := '';
    FMarkStr := '';
    FMarkName := '';
    HideButton.visible := false;
    AddCupButton.visible := (MainList.Items.count < 1);
    DeleteButton.visible := false;
    DescEdit.visible := false;
    CourseEditPanel.visible := false;
    NameEdit.visible := false;
    SetEditPanel (panSelect);
    IconImage.Picture.LoadFromFile (iiResDir + SEP + 'noneicon.png');
  end else begin
    ss := MainList.Items[MainList.ItemIndex];
    FMarkName := BareStr (ss);
    FMarkIdx := MainList.ItemIndex+1;  // + 1: No event entry at top
    FMarkStr := EventList[iiEventNum][FMarkIdx];
    FMarkStruct := ParsStr (FMarkStr, 'struct');
    AddCupButton.visible := true;
    DeleteButton.visible := true;
    CourseBox.color := clWhite;
    CourseBox.enabled := true;
    NameEdit.Visible := true;
    HideButton.visible := true;

    if FMarkStruct = 'course' then begin
      NameEdit.Text := ParsStr (CourseNames, FMarkName);
      IconImage.Picture.LoadFromFile(iiResDir + SEP + 'courseicon.png');
      DescEdit.visible := true;
      DescEdit.Text := ParsStr (CourseDesc, FMarkName);
      CourseEditPanel.visible := true;
      EasyHerr.value := ParsInt (FMarkStr, 'her1', 0);
      NormalHerr.value := ParsInt (FMarkStr, 'her2', 0);
      HardHerr.value := ParsInt (FMarkStr, 'her3', 0);
      EasyTime.value := ParsInt (FMarkStr, 'time1', 0);
      NormalTime.value := ParsInt (FMarkStr, 'time2', 0);
      HardTime.value := ParsInt (FMarkStr, 'time3', 0);
      if ParsStr (FMarkStr, 'wind') = 'yes'
        then WindCheck.checked := true else WindCheck.checked :=false;
      if ParsStr (FMarkStr, 'snow') = 'yes'
        then SnowCheck.checked := true else SnowCheck.checked :=false;
      cond := ParsStr (FMarkStr, 'cond');
      if cond = 'sunny' then CondRadio.ItemIndex := 0
      else if cond = 'cloudy' then CondRadio.ItemIndex := 1
      else CondRadio.ItemIndex := 2;
      if ParsInt (FMarkStr, 'opposs', 0) = 0 then begin
        OppCheck.visible := false;
      end else begin
        OppCheck.Visible := true;
        OppCheck.Checked := (ParsInt (FMarkStr, 'opp', 0) > 0);
      end;

    end else if FMarkStruct = 'cup' then begin
      NameEdit.Text := ParsStr (FMarkStr, 'trivname');
      DescEdit.visible := false;
      CourseEditPanel.visible := false;
      IconImage.Picture.LoadFromFile(iiResDir + SEP + 'cupicon.png');
      if (MainList.Items.count > 1) and (MainList.ItemIndex < 1)
        then DeleteButton.visible := false;
    end;
  end;
end;

procedure TMain.AddCourse; {-----------------------------}
var idx, eidx: integer;
    name, name1, trivname, desc, coursestr: String;
begin
  if MainList.ItemIndex < 0 then exit;
  name := CourseBox.Items [CourseBox.ItemIndex];
  name1 := '[' + name + ']';
  idx := ParsInt (CourseIdx, name, -1);
  if (idx >= 0) and (idx < CourseList.Count) then begin
    coursestr := CourseList[idx];
    if pos (name1, CourseNames) = 0
      then CourseNames := CourseNames + name1 + ParsStr (courseStr, 'trivname');
    if pos (name1, CourseDesc) = 0
      then CourseDesc := CourseDesc + name1 + ParsStr (courseStr, 'desc');
    SetParsInt (coursestr, 'ev', iiEventNum);
    eidx := MainList.ItemIndex + 1;
    EventList[iiEventNum].Insert (eidx+1, coursestr);

    ShowMainList;
    MainList.ItemIndex := eidx;
    SetMark;
  end;
end;

procedure TMain.AddCup; {--------------------------------------}
var nr, idx, po: integer;
    name, trivname, eventstr: String;
begin
  if MainList.ItemIndex >= -5 then begin
    nr := 0;
    repeat
      inc(nr);
      po := pos ('-my_cup_' + IntToStr (nr) + '-', CupNameStr);
    until po = 0;
    name := 'my_cup_' + inttostr (nr);
    trivname := 'My Cup ' + inttostr (nr);
    idx := MainList.ItemIndex + 1;
    eventstr := '[struct]cup[name]' + name  + '[grp]orig[trivname]' + trivname;
    SetParsInt (eventstr, 'ev', iiEventNum);
    EventList[iiEventNum].Insert (idx+1, eventstr);
    CupNameStr := CupNameStr + '-' + name + '-';

    ShowMainList;
    MainList.ItemIndex := idx;
    SetMark;
  end;
end;

procedure TMain.ShowMainList; {--------------------------------}
var ss, name, struct: String;
    i: integer;
begin
  MainList.Items.Clear;
  for i := 0 to EventList[iiEventNum].count-1 do begin
    ss := EventList[iiEventNum][i];
    struct := ParsStr (ss, 'struct');
    name := ParsStr (ss, 'name');
    if struct = 'cup' then MainList.Items.Add (name)
    else if struct = 'course' then MainList.Items.Add ('    ' + name);
  end;
end;

{--------------------------------------------------------------}

procedure TMain.CheckStructure; {------------------------------}
begin
  if iiCourseDir = '' then iiCourseDirOK := false
    else iiCourseDirOK := FileExists (iiCourseDir + SEP + 'course_idx.tcl');
  if iiCourseDirOK then begin
    B_MakePathes;
    iiBackupOK := DirectoryExists (iiBackupDir);
    iiPreparationOK := DirectoryExists (iiObjectsDir);
  end;
  BackupButton.visible := false;
  CourseDirButton.visible := false;
  PrepButton.visible := false;

  begin
    if iiCourseDirOK then begin
      CourseDirPanel.caption := 'ok';
      BackupPanel.Color := clWhite;
      PrepPanel.Color := clWhite;
      if iiBackupOK then begin
        BackupPanel.caption := 'ok';
      end else begin
        BackupPanel.caption := 'not done yet';
        BackupButton.visible := true;
      end;

      if iiPreparationOK then begin
        PrepPanel.caption := 'ok';
        B_MakeCourseList;
        B_ReadCourseList (CourseBox.Items);
        B_LoadEventList;
        B_LoadEnvList;
      end else begin
        PrepPanel.caption := 'not done yet';
        PrepButton.visible := true;
      end;
      StartButton.visible := iiPreparationOK;

    end else begin // not iiCoursedirOK
      CourseDirPanel.caption := 'failed';
      BackupPanel.Color := clGray;
      PrepPanel.Color := clGray;
      CourseDirButton.visible := true;
      StartButton.visible := false;
    end;
  end;
end;

procedure TMain.SetCourseDir; {--------------------------------}
begin
  if iiCourseDirOK and DirectoryExists (iiCourseDir) then
    CourseDirForm.DirTree.directory := iiCourseDir;
  if CourseDirForm.ShowModal = mrOK then begin
    iiCourseDir := CourseDirForm.DirTree.Directory;
    if iiCourseDir[length(iiCourseDir)] = SEP then Delete (iiCourseDir, length(iiCourseDir), 1);
    CheckStructure;
  end;
end;

procedure TMain.BackupCourses; {-------------------------------}
begin
  Application.ProcessMessages;
  Progress.visible := true;
  if Progress.visible then begin
    Progress.Position := 10;
    ForceDirectories (iiBackupDir);
    Progress.Position := 50;
    XCopy (iiCourseDir, iiBackupDir);
  end;
  Progress.visible := false;
  CheckStructure;
end;

procedure TMain.Preparations; {================================}
var i, j, fcount: integer;
    source, dest, fi, cup, path, typ, ss, mess: String;
begin  {............................................}
  Application.ProcessMessages;
  Progress.visible := true;
  if not iiCourseDirOK then begin
    exit;
  end;

  Application.ProcessMessages;

  Progress.Position := 10;
  ForceDirectories (iiShareDir);
  ForceDirectories (iiObjectsDir);

  mess := 'load file list - ';
  if FileExists (iiResDir + '/filelist') then begin
    FileList.LoadFromFile (iiResDir + '/filelist');
    iiFilelistOK := true;
    mess := mess + 'ok';
  end else begin
    iiFilelistOK := false;
    mess := mess + 'failed';
  end;

  if iiFileListOK then begin
    fcount := FileList.count;
    if FileList.count > 0 then for i := 0 to FileList.count-1 do begin
      Progress.Position := i * 100 div fcount;

      ss := FileList[i];
      cup := ParsStr (ss, 'cup');
      typ := ParsStr (ss, 'typ');
      fi  := ParsStr (ss, 'file');
      if (typ = 'o') or (typ = 't') then begin // object.strip or texture
        source := iiCourseDir + SEP + cup + SEP + fi;
        dest := iiObjectsDir + SEP + fi;
        CpFile (source, dest);
      end else if typ = 'e' then begin // environment file
(*        source := iiCourseDir + SEP + cup + SEP + fi;
        dest := iiEnvDir + SEP + fi;
        CpFile (source, dest);*)
      end;
    end;

    source := iiResDir + SEP + 'objects.tcl';
    dest := iiObjectsDir + SEP + 'objects.tcl';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + 'object_textures.tcl';
    dest := iiObjectsDir + SEP + 'object_textures.tcl';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + 'sunny_light.tcl';
    dest := iiShareDir + SEP + 'sunny_light.tcl';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + 'sunset_light.tcl';
    dest := iiShareDir + SEP + 'sunset_light.tcl';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + 'foggy_light.tcl';
    dest := iiShareDir + SEP + 'foggy_light.tcl';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + 'trophy.tcl';
    dest := iiShareDir + SEP + 'trophy.tcl';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + 'trophy_share.obj.strip';
    dest := iiShareDir + SEP + 'trophy_share.obj.strip';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + 'trophy_share.png';
    dest := iiShareDir + SEP + 'trophy_share.png';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + 'trophy_share_env.png';
    dest := iiShareDir + SEP + 'trophy_share_env.png';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + '_objects.tcl';
    dest := iiShareDir + SEP + 'objects.tcl';
    if FileExists (source) then CpFile (source, dest);

    source := iiResDir + SEP + '_object_textures.tcl';
    dest := iiShareDir + SEP + 'object_textures.tcl';
    if FileExists (source) then CpFile (source, dest);

    CheckStructure;
  end else begin // not iiFilelistOK

  end;

  Progress.Visible := false;
end;

{--------------------------------------------------------------}
{                        Main                                  }
{--------------------------------------------------------------}

procedure TMain.FormCreate; {----------------------------------}
var mess: String;
    i: integer;
begin
  top := 0; left := 0;
  width := 800; height := 560;
  DecimalSeparator:='.';
  Randomize;
  FileList := TStringList.Create;
  EnvList := TStringList.Create;
  CourseList := TStringList.Create;
  for i := 0 to 4 do EventList[i] := TStringList.Create;
  for i := 0 to 4 do iiOrder[i] := i;

  iiLanguage := 'english';
  iiCourseDirOK := false;
  iiEventlistOK := false;
  iiBackupOK := false;
  iiPreparationOK := false;
  MainChange := false;
  EditChange := false;

  iiResDir := ProgDir + 'res';
  iiConfDir := HomeDir + SEP + '.tuxmanager';
  if not DirectoryExists (iiConfDir) then ForceDirectories (iiConfDir);
  B_LoadConfig;

  SetMainPanel (panCover);
  StartButton.SetFocus;
  iiEventMode := emAdd;
  iiLightMode := tlSunny;
  iiViewMode := vmBack;
  ViewRadio.ItemIndex := 1;
  iiEnvMode := 'beginner';
  EnvRadio.ItemIndex := 0;

  CheckStructure;
end;

procedure TMain.FormShow(Sender: TObject);
begin
  CourseBox.ItemIndex := -1;
  SetEditPanel (panSelect);
end;

procedure TMain.FormDestroy(Sender: TObject);
var i: integer;
begin
  for i := 0 to 4 do EventList[i].Free;
  FileList.Free;
  CourseList.Free;
  EnvList.Free;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if iiEventlistOK then B_SaveEventList;
  B_SaveEnvList;
  B_SaveConfig;
end;

procedure TMain.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

procedure TMain.AddCupButtonClick(Sender: TObject);
begin
  AddCup;
end;

procedure TMain.MainListClick(Sender: TObject);
begin
  SetMark;
end;

procedure TMain.Button1Click(Sender: TObject);
begin
  liste99.items:=CourseList;
  edit2.text := CourseIdx;
end;

procedure TMain.FillEventCombo; {------------------------------}
var ev: integer;
    list: array[0..4] of String;
begin
  EventCombo.Items.Clear;
  for ev := 0 to 4 do list[ev] := EventList[ev][0];
  EventCombo.Items.Add (ParsStr (list[0], 'trivname'));
  EventCombo.Items.Add (ParsStr (list[1], 'trivname'));
  EventCombo.Items.Add (ParsStr (list[2], 'trivname'));
  EventCombo.Items.Add (ParsStr (list[3], 'trivname'));
  EventCombo.Items.Add (ParsStr (list[4], 'trivname'));
end;

procedure TMain.StartbuttonClick(Sender: TObject);
begin
  FillEventCombo;
  EventCombo.ItemIndex := 2;
  iiEventNum := EventCombo.ItemIndex;

  TopCover.visible := false;
  SetMainPanel (panWork);
  mmFile.enabled := true;
  mmEvents.enabled := true;
  mmSettings.enabled := true;
//  mmEnv.enabled := true;
  ShowMainList;
  MainList.ItemIndex := -1;
  SetMark;
  Dummy.Setfocus;
  if not iiConfEx then mmLangClick (self);
end;

procedure TMain.BackupButtonClick(Sender: TObject);
begin
  BackupCourses;
end;

procedure TMain.PrepButtonClick(Sender: TObject);
begin
   Preparations;
end;

procedure TMain.SpeedButton3Click(Sender: TObject);
begin
  HelpPanel.visible := true;
  HelpCloseButton.SetFocus;
end;

procedure TMain.HelpCloseButtonClick(Sender: TObject);
begin
  HelpPanel.visible := false;
  StartButton.SetFocus;
end;

procedure TMain.Button3Click(Sender: TObject);
begin
  liste99.items:=EventList[iiEventNum];
end;

procedure TMain.Button5Click(Sender: TObject);
begin
  SetEditPanel (panSelect);
end;

procedure TMain.DeleteButtonClick(Sender: TObject);
var idx: integer;
    ss, struct: String;
begin
  idx := MainList.ItemIndex;
  if idx < 0 then exit;
  ss := EventList[iiEventNum][idx];
  struct := ParsStr (ss, 'struct');

  EventList[iiEventNum].Delete (idx + 1);
  if struct = 'cup' then B_MakeNameStr;
  ShowMainList;
  if idx >= MainList.Items.Count
    then MainList.ItemIndex := MainList.Items.count-1
    else MainList.ItemIndex := idx;
  SetMark;
end;

procedure TMain.MainRegisterChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := MainChange;
end;

procedure TMain.EditRegisterChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := EditChange;
end;

procedure TMain.EventComboChange(Sender: TObject);
begin
  iiEventNum := EventCombo.ItemIndex;
  MainList.ItemIndex := -1;
  ShowMainList;
  SetMark;
end;

procedure TMain.CourseBoxClick(Sender: TObject);
begin
  if CourseBox.ItemIndex >= 0 then AddCourse;
end;

procedure TMain.Button6Click(Sender: TObject);
begin
  Edit2.text := CupNamestr;
end;

procedure TMain.Button7Click(Sender: TObject);
begin
  edit2.Text := FLAngStr;
end;

procedure TMain.Button8Click(Sender: TObject);
begin
  liste99.items := EnvList;
  edit2.text := CubeList;
end;

procedure TMain.Button9Click(Sender: TObject);
begin
liste99.items:=FEvents;
end;

procedure TMain.Button10Click(Sender: TObject);
begin
  edit2.text := EnvIdx;
end;

procedure TMain.mmQuitClick(Sender: TObject);
begin
  Close;
end;

procedure TMain.mmScandirClick(Sender: TObject);
begin
  B_MakeCourseList;
  B_ReadCourseList (CourseBox.Items);
end;

procedure TMain.CourseDirButtonClick(Sender: TObject);
begin
  SetCourseDir;
end;

procedure TMain.NameEditChange(Sender: TObject);
begin
  if FMarkStruct = 'cup' then begin
    SetParsStr (FMarkStr, 'trivname', NameEdit.Text);
    EventList[iiEventNum][FMarkIdx] := FMarkStr;
  end else if FMarkStruct = 'course' then begin
    SetParsStr (CourseNames, FMarkName, NameEdit.Text);
  end;
end;

procedure TMain.DescEditChange(Sender: TObject);
begin
//  SetParsStr (FMarkStr, 'desc', DescEdit.text);
//  EventList[iiEventNum][FMarkIdx] := FMarkStr;
  SetParsStr (CourseDesc, FMarkName, DescEdit.Text);
end;

procedure TMain.EasyHerrChanged(Sender: TObject; NewValue: Integer);
begin
  SetParsInt (FMarkStr, 'her1', EasyHerr.value);
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.NormalHerrChanged(Sender: TObject; NewValue: Integer);
begin
  SetParsInt (FMarkStr, 'her2', NormalHerr.value);
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.HardHerrChanged(Sender: TObject; NewValue: Integer);
begin
  SetParsInt (FMarkStr, 'her3', HardHerr.value);
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.EasyTimeChanged(Sender: TObject; NewValue: Integer);
begin
  SetParsInt (FMarkStr, 'time1', EasyTime.value);
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.NormalTimeChanged(Sender: TObject; NewValue: Integer);
begin
  SetParsInt (FMarkStr, 'time2', NormalTime.value);
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.HardTimeChanged(Sender: TObject; NewValue: Integer);
begin
  SetParsInt (FMarkStr, 'time3', HardTime.value);
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.WindCheckClick(Sender: TObject);
begin
  if WindCheck.checked then SetParsStr (FMarkStr, 'wind', 'yes')
    else SetParsStr (FMarkStr, 'wind', 'no');
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.SnowCheckClick(Sender: TObject);
begin
  if SnowCheck.checked then SetParsStr (FMarkStr, 'snow', 'yes')
    else SetParsStr (FMarkStr, 'snow', 'no');
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.CondRadioClick(Sender: TObject);
begin
  case CondRadio.ItemIndex of
    0: SetParsStr (FMarkStr, 'cond', 'sunny');
    1: SetParsStr (FMarkStr, 'cond', 'cloudy');
    2: SetParsStr (FMarkStr, 'cond', 'night');
  end;
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.HideButtonClick(Sender: TObject);
begin
  if HidePanel.visible then begin
    HidePanel.visible := false;
    HideButton.caption := 'Hide parameters';
  end else begin
    HidePanel.visible := true;
    HideButton.caption := 'Show parameters';
  end;
end;

procedure TMain.OppCheckClick(Sender: TObject);
begin
  if OppCheck.checked then SetParsStr (FMarkStr, 'opp', '1')
    else SetParsStr (FMarkStr, 'opp', '0');
  EventList[iiEventNum][FMarkIdx] := FMarkStr;
end;

procedure TMain.mmRenameClick(Sender: TObject);
var idx: integer;
begin
  if RenameEventForm.ShowModal = mrOK then begin
    Idx := EventCombo.ItemIndex;
    FillEventCombo;
    EventCombo.ItemIndex := -1;
    EventCombo.ItemIndex := idx;
  end;
end;

procedure TMain.mmResetClick(Sender: TObject);
var idx: integer;
begin
  if WarnForm.ShowModal = mrOK then begin
    B_MakeEventList;
    B_MakeNameStr;
    idx := EventCombo.ItemIndex;
    FillEventCombo;
    EventCombo.ItemIndex := -1;
    EventCombo.ItemIndex := idx;
    iiEventListOK := true;
    ShowMainList;
    SetMark;
  end;
end;

procedure TMain.mmClearEventClick(Sender: TObject);
begin
  B_ClearEvent (iiEventNum);
  B_MakeNameStr;
  ShowMainList;
  SetMark;
end;

procedure TMain.mmClearAllEventsClick(Sender: TObject);
var ev: integer;
begin
  for ev := 0 to 4 do B_ClearEvent (ev);
  B_MakeNameStr;
  ShowMainList;
  SetMark;
end;

procedure TMain.mmConfigurationClick(Sender: TObject);
begin
  if not iiCourseDirOK then exit;
  ConfigWriteForm.flag := 1;
  ConfigWriteForm.Label2.caption := 'course_idx.tcl';
  if ConfigWriteForm.ShowModal = mrOK then begin
  end;
end;

procedure TMain.mmCourseOrderClick(Sender: TObject);
begin
  if not iiCourseDirOK then exit;
  if OrderForm.ShowModal = mrOK then begin
  end;
end;

procedure TMain.mmInstallClick(Sender: TObject);
begin
  if not iiCourseDirOK then exit;
  if InstallForm.ShowModal = mrOK then begin
    B_MakeCourseList;
    B_ReadCourseList (CourseBox.Items);
  end;
end;

procedure TMain.mmNewCourseClick(Sender: TObject);
begin
  if not iiCourseDirOK then exit;
  if NewCourseForm.ShowModal = mrOK then begin
    B_MakeCourseList;
    B_ReadCourseList (CourseBox.Items);
  end;
end;

procedure TMain.mmEnvironmentClick(Sender: TObject);
begin
  SetMainPanel (panEnv);
  ShowEnv;
  EnvButton.visible := false;
  CupsButton.visible := true;
end;

procedure TMain.ShowEnv; {-------------------------------------}
var ss, light, dir, cube, src, preview: String;
    i, r, g, b: integer;
const comboidx: String = '[beginner]0[arctic]1[forest]2[mountain]3[glacier]4[swiss]5[common]6';
begin
  EnvMarkStr := B_EnvStr;
  SunnyLightPanel.ParentColor:=true;
  SunsetLightPanel.ParentColor:=true;
  FoggyLightPanel.ParentColor:=true;
  case iiLightMode of
    tlSunny: SunnyLightPanel.Color := clBlack;
    tlSunset: SunsetLightPanel.Color := clBlack;
    tlFoggy: FoggyLightPanel.Color := clBlack;
  end;
  ss := B_EnvStr;
  r := ParsInt (ss, 'amb_r', 0);
  g := ParsInt (ss, 'amb_g', 0);
  b := ParsInt (ss, 'amb_b', 0);
  AmbientPanel.color := cCol (r, g, b);
  r := ParsInt (ss, 'diff_r', 0);
  g := ParsInt (ss, 'diff_g', 0);
  b := ParsInt (ss, 'diff_b', 0);
  DiffusePanel.color := cCol (r, g, b);
  r := ParsInt (ss, 'spec_r', 0);
  g := ParsInt (ss, 'spec_g', 0);
  b := ParsInt (ss, 'spec_b', 0);
  SpecularPanel.color := cCol (r, g, b);
  r := ParsInt (ss, 'fog_r', 0);
  g := ParsInt (ss, 'fog_g', 0);
  b := ParsInt (ss, 'fog_b', 0);
  FogPanel.color := cCol (r, g, b);
  r := ParsInt (ss, 'part_r', 0);
  g := ParsInt (ss, 'part_g', 0);
  b := ParsInt (ss, 'part_b', 0);
  ParticlePanel.color := cCol (r, g, b);
  Potrack1.Position := round (ParsFloat (ss, 'pos_1', 0) * 100);
  Potrack2.Position := round (ParsFloat (ss, 'pos_2', 0) * 100);
  Potrack3.Position := round (ParsFloat (ss, 'pos_3', 0) * 100);
  Pos1.text := ParsStr (ss, 'pos_1');
  Pos2.text := ParsStr (ss, 'pos_2');
  Pos3.text := ParsStr (ss, 'pos_3');

  dir := ParsStr (ss, 'dir');
  src := ParsStr (ss, 'src');
  cube := ParsStr (ss, 'cube');
  CubeCombo.ItemIndex := ParsInt (comboidx, src, -1);
  preview := iiCourseDir + SEP + src + SEP + ParsStr (ss, 'cube')
    + orCubeView [iiViewMode] + '.png';
  if FileExists (preview) then EnvPreview.picture.LoadFromFile (preview);
end;

procedure TMain.SunnyOpenButtonClick(Sender: TObject);
begin
  iiLightMode := tlSunny;
  ShowEnv;
end;

procedure TMain.SunsetOpenButtonClick(Sender: TObject);
begin
  iiLightMode := tlSunset;
  ShowEnv;
end;

procedure TMain.FoggyOpenButtonClick(Sender: TObject);
begin
  iiLightMode := tlFoggy;
  ShowEnv;
end;

procedure TMain.EnvRadioClick(Sender: TObject);
var idx: integer;
    dir: String;
begin
  idx := EnvRadio.ItemIndex;
  if idx >= 0 then begin
    iiEnvMode := EnvRadio.Items[idx];
  end else iiEnvMode := '';
  ShowEnv;
end;

procedure TMain.ViewRadioClick(Sender: TObject);
begin
  iiViewMode := ViewRadio.ItemIndex + 1;
  ShowEnv;
end;

procedure TMain.AmbientPanelClick(Sender: TObject);
var col: TColor;
    r, g, b: integer;
begin
  ColorDialog.color:=AmbientPanel.color;
  if ColorDialog.Execute then begin
    col := ColorDialog.color;
    r := cRed (col);
    g := cGreen (col);
    b := cBlue (col);
    SetParsInt (EnvMarkStr, 'amb_r', r);
    SetParsInt (EnvMarkStr, 'amb_g', g);
    SetParsInt (EnvMarkStr, 'amb_b', b);
    SetParsStr (EnvMarkStr, 'changed', '1');
    B_SetEnvStr (EnvMarkStr);
    ShowEnv;
  end;
end;

procedure TMain.DiffusePanelClick(Sender: TObject);
var col: TColor;
    r, g, b: integer;
begin
  ColorDialog.color:=DiffusePanel.color;
  if ColorDialog.Execute then begin
    col := ColorDialog.color;
    r := cRed (col);
    g := cGreen (col);
    b := cBlue (col);
    SetParsInt (EnvMarkStr, 'diff_r', r);
    SetParsInt (EnvMarkStr, 'diff_g', g);
    SetParsInt (EnvMarkStr, 'diff_b', b);
    SetParsStr (EnvMarkStr, 'changed', '1');
    B_SetEnvStr (EnvMarkStr);
    ShowEnv;
  end;
end;

procedure TMain.SpecularPanelClick(Sender: TObject);
var col: TColor;
    r, g, b: integer;
begin
  ColorDialog.color:=SpecularPanel.color;
  if ColorDialog.Execute then begin
    col := ColorDialog.color;
    r := cRed (col);
    g := cGreen (col);
    b := cBlue (col);
    SetParsInt (EnvMarkStr, 'spec_r', r);
    SetParsInt (EnvMarkStr, 'spec_g', g);
    SetParsInt (EnvMarkStr, 'spec_b', b);
    SetParsStr (EnvMarkStr, 'changed', '1');
    B_SetEnvStr (EnvMarkStr);
    ShowEnv;
  end;
end;

procedure TMain.FogPanelClick(Sender: TObject);
var col: TColor;
    r, g, b: integer;
begin
  ColorDialog.color:=FogPanel.color;
  if ColorDialog.Execute then begin
    col := ColorDialog.color;
    r := cRed (col);
    g := cGreen (col);
    b := cBlue (col);
    SetParsInt (EnvMarkStr, 'fog_r', r);
    SetParsInt (EnvMarkStr, 'fog_g', g);
    SetParsInt (EnvMarkStr, 'fog_b', b);
    SetParsStr (EnvMarkStr, 'changed', '1');
    B_SetEnvStr (EnvMarkStr);
    ShowEnv;
  end;
end;

procedure TMain.ParticlePanelClick(Sender: TObject);
var col: TColor;
    r, g, b: integer;
begin
  ColorDialog.color:=ParticlePanel.color;
  if ColorDialog.Execute then begin
    col := ColorDialog.color;
    r := cRed (col);
    g := cGreen (col);
    b := cBlue (col);
    SetParsInt (EnvMarkStr, 'part_r', r);
    SetParsInt (EnvMarkStr, 'part_g', g);
    SetParsInt (EnvMarkStr, 'part_b', b);
    SetParsStr (EnvMarkStr, 'changed', '1');
    B_SetEnvStr (EnvMarkStr);
    ShowEnv;
  end;
end;

procedure TMain.CubeComboClick(Sender: TObject);
var sss, src, dir, cube: String;
    idx: integer;
begin
  src := CubeCombo.Items[CubeCombo.ItemIndex];
  dir := ParsStr (EnvMarkStr, 'dir');
  SetParsStr (EnvMarkStr, 'src', src);
  SetParsStr (EnvMarkStr, 'cube', B_Cube(src));
  SetParsStr (EnvMarkStr, 'changed', '1');
  B_SetEnvStr (EnvMarkStr);
  ShowEnv;
end;

procedure TMain.SaveEnvButtonClick(Sender: TObject);
begin
  ConfigWriteForm.flag := 2;
  ConfigWriteForm.Label2.caption := 'sunny_light.tcl    sunset_light.tcl    foggy_light.tcl';
  ConfigWriteForm.label3.caption := '';
  if ConfigWriteForm.ShowModal = mrOK then begin
  end;
end;

procedure TMain.Potrack1Change(Sender: TObject);
begin
  Pos1.text := Float_Str (Potrack1.Position / 100, 2);
  SetParsStr (EnvMarkStr, 'pos_1', Pos1.text);
  SetParsStr (EnvMarkStr, 'changed', '1');
  B_SetEnvStr (EnvMarkStr);
  ShowEnv;
end;

procedure TMain.Potrack2Change(Sender: TObject);
begin
  Pos2.text := Float_Str (Potrack2.Position / 100, 2);
  SetParsStr (EnvMarkStr, 'pos_2', Pos2.text);
  SetParsStr (EnvMarkStr, 'changed', '1');
  B_SetEnvStr (EnvMarkStr);
  ShowEnv;
end;

procedure TMain.Potrack3Change(Sender: TObject);
begin
  Pos3.text := Float_Str (Potrack3.Position / 100, 2);
  SetParsStr (EnvMarkStr, 'pos_3', Pos3.text);
  SetParsStr (EnvMarkStr, 'changed', '1');
  B_SetEnvStr (EnvMarkStr);
  ShowEnv;
end;

procedure TMain.mmEnvResetClick(Sender: TObject);
begin
  if FileExists (iiCourseDir + SEP + 'environment.ogl') then begin
    EnvList.LoadFromFile (iiCourseDir + SEP + 'environment.ogl');
  end;
  B_MakeEnvIdx;
  ShowEnv;
end;

procedure TMain.mmLangClick(Sender: TObject);
var idx: integer;
begin
  if LangForm.ShowModal = mrOK then begin
    B_MakeCourseList;
    B_MakeEventList;
    B_MakeNameStr;
    idx := EventCombo.ItemIndex;
    FillEventCombo;
    EventCombo.ItemIndex := -1;
    EventCombo.ItemIndex := idx;
    iiEventListOK := true;
    ShowMainList;
    SetMark;
  end;
end;

procedure TMain.CupsButtonClick(Sender: TObject);
begin
  SetMainPanel (panWork);
  Dummy.SetFocus;
  EnvButton.visible := true;
  CupsButton.visible := false;
end;

procedure TMain.mmAboutClick(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

end.




